/* config_dialog.h
 *
 * Andreas Wst
 *
 */

#ifndef CONFIG_DIALOG_H
#define CONFIG_DIALOG_H

#include "structs.h"

#include <qdialog.h>
#include <qtabdialog.h>

#include "dayaveragedialog.h"
#include "browserdialog.h"

class ConfigDialog : public QDialog
{

        Q_OBJECT

public:

  ConfigDialog (QWidget *, const char *name, struct CONFIGURATION_DATA *);
  ~ConfigDialog();

public slots:
 
  // ok button von tabdialog gedrckt
  void okPressed ();

  // cancel button gedrckt
  void cancelPressed ();

protected:
 
  QTabDialog *tabdialog;
  DayAverage *da;
  Browser *br;

  struct CONFIGURATION_DATA *conf;
  
};

#endif		
