/* wwdialog.h
 *
 * Andreas Wst
 *
 */

#ifndef WWDIALOG_H
#define WWDIALOG_H


#include <qframe.h>
#include <qlabel.h>
#include <qdialog.h>
#include <qbuttongroup.h>
#include <qpushbutton.h>
#include <qdir.h>
#include <qregexp.h>
#include <qlistview.h>

#include <stdlib.h>
#include <stdio.h>
#include <fstream.h>


class WWDialog : public QDialog
{

        Q_OBJECT

public:
 	WWDialog ( QWidget *, const char *name);
        ~WWDialog();

public slots:

  void deleteItem ();
  void openPressed ();


signals:

  void doneOk ();
  void returnChartFile (QString);
  void returnChartName (QString);

protected:

  void loadFiles ();



private:
  
  QString pfad;

  QFrame *frame;
  QPushButton *cancel, *open, *del;
  QListView *lv;

  // struktur fr chart-daten
  struct chart_daten
  {
    double kurs;
    double open, high, low;
    long volume;
    unsigned char tag, monat;
    int jahr;
  } kurs;



};

#endif		
